# HG changeset patch
# User Christophe Capon <christophe.capon@vilogia.fr>
# Date 1270092178 -7200
# Branch 5.3.0
# Node ID da9260dcce12b38f7c9b5bfb3294c8bc8e6becfe
# Parent  b193dc341426f5ed53912eb1c958f22bb01db0e0
Expired document alerts

diff -r b193dc341426 -r da9260dcce12 nuxeo-platform-alert-obsolete-core/src/main/java/org/nuxeo/ecm/alert/obsolete/core/DocumentInfo.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/nuxeo-platform-alert-obsolete-core/src/main/java/org/nuxeo/ecm/alert/obsolete/core/DocumentInfo.java	Thu Apr 01 05:22:58 2010 +0200
@@ -0,0 +1,61 @@
+package org.nuxeo.ecm.alert.obsolete.core;
+
+import java.text.SimpleDateFormat;
+import java.util.Date;
+
+public class DocumentInfo {
+
+    private static SimpleDateFormat df = new SimpleDateFormat("dd/MM/yyyy");
+
+    private String docUrl;
+
+    private String docTitle;
+
+    public Date getExpiredDate() {
+        return expiredDate;
+    }
+
+    public void setExpiredDate(Date expiredDate) {
+        this.expiredDate = expiredDate;
+    }
+
+    public boolean isExpired() {
+        return expired;
+    }
+
+    public boolean getExpired() {
+        return expired;
+    }
+
+    public void setExpired(boolean expired) {
+        this.expired = expired;
+    }
+
+    private Date expiredDate;
+
+    private boolean expired;
+
+    public void setDocUrl(String docUrl) {
+        this.docUrl = docUrl;
+    }
+
+    public String getDocUrl() {
+        return docUrl;
+    }
+
+    public void setDocTitle(String docTitle) {
+        this.docTitle = docTitle;
+    }
+
+    public String getDocTitle() {
+        return docTitle;
+    }
+
+    public String getExpiredDateStr() {
+        if (expiredDate == null)
+            return "-";
+        else
+            return df.format(expiredDate);
+    }
+
+}
diff -r b193dc341426 -r da9260dcce12 nuxeo-platform-alert-obsolete-core/src/main/java/org/nuxeo/ecm/alert/obsolete/core/ObsoleteAlertProvider.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/nuxeo-platform-alert-obsolete-core/src/main/java/org/nuxeo/ecm/alert/obsolete/core/ObsoleteAlertProvider.java	Thu Apr 01 05:22:58 2010 +0200
@@ -0,0 +1,181 @@
+package org.nuxeo.ecm.alert.obsolete.core;
+
+import java.util.ArrayList;
+import java.util.Calendar;
+import java.util.Collection;
+import java.util.Date;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.commons.logging.Log;
+import org.apache.commons.logging.LogFactory;
+import org.nuxeo.ecm.alert.Alert;
+import org.nuxeo.ecm.alert.AlertContext;
+import org.nuxeo.ecm.alert.AlertProvider;
+import org.nuxeo.ecm.alert.UserAlerts;
+import org.nuxeo.ecm.alert.util.FreemarkerMethods;
+import org.nuxeo.ecm.core.api.ClientException;
+import org.nuxeo.ecm.core.api.CoreSession;
+import org.nuxeo.ecm.core.api.DocumentLocation;
+import org.nuxeo.ecm.core.api.DocumentModel;
+import org.nuxeo.ecm.core.api.DocumentModelList;
+import org.nuxeo.ecm.core.api.DocumentRef;
+import org.nuxeo.ecm.core.api.impl.DocumentLocationImpl;
+import org.nuxeo.ecm.platform.ec.notification.service.NotificationServiceHelper;
+import org.nuxeo.ecm.platform.rendering.RenderingResult;
+import org.nuxeo.ecm.platform.rendering.RenderingService;
+import org.nuxeo.ecm.platform.url.DocumentViewImpl;
+import org.nuxeo.ecm.platform.url.api.DocumentView;
+import org.nuxeo.ecm.platform.url.api.DocumentViewCodecManager;
+import org.nuxeo.em.usersettings.alert.types.AlertSettingsWrapper;
+import org.nuxeo.runtime.api.Framework;
+
+public class ObsoleteAlertProvider implements AlertProvider {
+
+    private DocumentViewCodecManager docLocator = null;
+
+    private static final Log log = LogFactory.getLog(ObsoleteAlertProvider.class);
+
+    public Map<String, UserAlerts> getAllPendingAlerts(CoreSession coreSession)
+            throws ClientException {
+
+        Map<String, UserAlerts> result = new HashMap<String, UserAlerts>();
+        
+        // NULL is not handled
+        String query = "select * from Document where dc:expired between '1980-01-01' and '2200-01-01' ";
+
+        DocumentModelList docs = coreSession.query(query);
+
+        for (DocumentModel doc : docs) {
+            String userName = (String) doc.getProperty("dublincore", "creator");
+            UserAlerts ua = getCurrentUserAlerts(result, userName);
+            ua.setUserName(userName);
+            ua.getAlerts().add(
+                    new Alert("ObsoleteAlertProvider", "obsolete", doc.getRef()));
+        }
+
+        return result;
+
+    }
+
+    private UserAlerts getCurrentUserAlerts(Map<String, UserAlerts> result,
+            String userName) {
+
+        if (!result.containsKey(userName)) {
+
+            UserAlerts alerts = new UserAlerts(userName);
+
+            result.put(userName, alerts);
+
+        }
+
+        UserAlerts alerts = result.get(userName);
+
+        return alerts;
+    }
+
+    public String renderAlerts(CoreSession coreSession, RenderingService rs,
+            String userName, List<Alert> alerts, DocumentModel userSettingsDoc,
+            AlertContext ctxt) {
+
+        String result = "";
+
+        try {
+
+            AlertSettingsWrapper w = new AlertSettingsWrapper(userSettingsDoc);
+
+            if (!w.getIncludeExpiredDocuments())
+                return result;
+
+            List<DocumentInfo> docs = new ArrayList<DocumentInfo>();
+
+            for (Alert a : alerts) {
+
+                if (a.getAlertProviderName() == "ObsoleteAlertProvider") {
+
+                    DocumentModel dm = coreSession.getDocument((DocumentRef) a.getAlertData());
+                    DocumentInfo di = getEligibleDocInfo(dm, w);
+                    if (null != di) {
+                        docs.add(di);
+                    }
+
+                }
+
+            }
+
+            ObsoleteRenderingContext ctx = new ObsoleteRenderingContext();
+            ctx.put("template", "obsoleteAlert");
+            ctx.put("docs", docs);
+            ctx.put("format", w.getAlertDeliveryChannel());
+            FreemarkerMethods.add(ctx);
+
+            Collection<RenderingResult> render = rs.process(ctx);
+            if (render.size() > 0) {
+                result = (String) render.iterator().next().getOutcome();
+            }
+        } catch (Exception e) {
+            log.error("Unable to render obsolete alerts", e);
+        }
+
+        return result;
+
+    }
+
+    private DocumentInfo getEligibleDocInfo(DocumentModel dm, AlertSettingsWrapper w)
+            throws ClientException {
+
+        Date now = new Date();
+        
+        Calendar dueCal = (Calendar) dm.getProperty("dublincore", "expired");
+        Date due = dueCal.getTime();
+        long days = (due.getTime() - now.getTime()) / (1000 * 60 * 60 * 24);
+
+        if (w.getIncludeExpiredDocuments() && (due.before(now) || days <= w.getIncludeExpiredDocumentsDelay())) {
+            DocumentInfo di = new DocumentInfo();
+            di.setDocTitle(dm.getTitle());
+            di.setDocUrl(getDocLocation(dm));
+            di.setExpired(due.before(now));
+            di.setExpiredDate(due);
+            return di;
+        }
+
+        return null;
+
+    }
+
+    public DocumentViewCodecManager getLocator() {
+
+        if (docLocator == null) {
+            try {
+                docLocator = Framework.getService(DocumentViewCodecManager.class);
+            } catch (Exception e) {
+
+            }
+        }
+
+        return docLocator;
+    }
+
+    public String getDocLocation(DocumentModel doc) {
+
+        DocumentLocation docLoc = new DocumentLocationImpl(doc);
+        DocumentView docView = new DocumentViewImpl(docLoc);
+        docView.setViewId("view_documents");
+
+        return getLocator().getUrlFromDocumentView(
+                docView,
+                true,
+                NotificationServiceHelper.getNotificationService().getServerUrlPrefix());
+
+    }
+
+    public List<String> getTemplateList() {
+
+        List<String> result = new ArrayList<String>();
+        result.add("obsoleteAlert");
+        return result;
+
+    }
+
+}
diff -r b193dc341426 -r da9260dcce12 nuxeo-platform-alert-obsolete-core/src/main/java/org/nuxeo/ecm/alert/obsolete/core/ObsoleteRenderingContext.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/nuxeo-platform-alert-obsolete-core/src/main/java/org/nuxeo/ecm/alert/obsolete/core/ObsoleteRenderingContext.java	Thu Apr 01 05:22:58 2010 +0200
@@ -0,0 +1,42 @@
+package org.nuxeo.ecm.alert.obsolete.core;
+
+import java.util.List;
+
+import org.nuxeo.ecm.core.api.DocumentModel;
+import org.nuxeo.ecm.platform.rendering.RenderingEngine;
+import org.nuxeo.ecm.platform.rendering.impl.DefaultRenderingContext;
+
+public class ObsoleteRenderingContext extends DefaultRenderingContext {
+
+    private static final long serialVersionUID = 1626664498541223492L;
+
+    public static final String CTX_PARAM_DOCUMENTS = "docs";
+
+    @Override
+    public <T> T getAdapter(Class<T> adapter) {
+        if (adapter.isAssignableFrom(getClass())) {
+            return adapter.cast(this);
+        } else if (adapter.isAssignableFrom(DocumentModel.class)) {
+            return adapter.cast(getDocuments());
+        }
+        return null;
+    }
+
+    public void setDocuments(List<DocumentModel> doc) {
+        put(CTX_PARAM_DOCUMENTS, doc);
+    }
+
+    @SuppressWarnings("unchecked")
+    public List<DocumentModel> getDocuments() {
+        return (List<DocumentModel>) get(CTX_PARAM_DOCUMENTS);
+    }
+
+    @Override
+    public boolean accept(RenderingEngine engine) {
+        if (engine.getFormatName().equals("obsoleteAlert"))
+            return true;
+        else
+            return false;
+    }
+
+}
\ No newline at end of file
diff -r b193dc341426 -r da9260dcce12 nuxeo-platform-alert-obsolete-core/src/main/resources/META-INF/MANIFEST.MF
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/nuxeo-platform-alert-obsolete-core/src/main/resources/META-INF/MANIFEST.MF	Thu Apr 01 05:22:58 2010 +0200
@@ -0,0 +1,20 @@
+Manifest-Version: 1.0
+Bundle-ManifestVersion: 2
+Bundle-Name: Nuxeo ECM Alert Core
+Bundle-SymbolicName: org.nuxeo.ecm.alert.obsolete.core;singleton:=true
+Bundle-Vendor: Nuxeo
+Bundle-Localization: bundle
+Bundle-ClassPath: .
+Bundle-Category: web,stateful
+Export-Package: org.nuxeo.ecm.alert.obsolete.core
+Eclipse-LazyStart: true
+Nuxeo-Component: OSGI-INF/obsolete-alerts-service-contrib.xml,
+ OSGI-INF/obsolete-alerts-notification-contrib.xml
+Require-Bundle: org.nuxeo.ecm.core.api,
+ org.nuxeo.ecm.core.event,
+ org.nuxeo.ecm.platform.notification.core,
+ org.nuxeo.ecm.platform.jbpm.core,
+ org.nuxeo.ecm.platform.jbpm.web,
+ org.nuxeo.ecm.platform.jbpm.api, 
+ org.nuxeo.ecm.alert.api
+ 
\ No newline at end of file
